#Sets the scripts current location as current directory for various editors like psise, vscode or powershell7
#if($psISE){$script:ScriptDir = Split-Path -Path $psISE.CurrentFile.FullPath}                                                                    #Powershell ISE Editor
if((Get-Host).Version.Major -gt "5"){$script:ScriptDir = $PSScriptRoot}else{$script:ScriptDir = $PSScriptRoot}                                  #Powershell V7 or v5
#if($env:TERM_PROGRAM -eq "vscode"){$script:ScriptDir = [System.IO.Path]::GetDirectoryName($psEditor.GetEditorContext().CurrentFile.Path)}       #Visual Studio Code
#if($null -ne $env:WT_SESSION){$script:ScriptDir  = (Get-Item .).FullName}                                                                       #Windows Terminal

$ScriptDir = $PSScriptRoot
Set-Location $ScriptDir 
# msg * $ScriptDir
#Run with admin permissions
Function Set-AdminPermissions {
    If (!([Security.Principal.WindowsPrincipal][Security.Principal.WindowsIdentity]::GetCurrent()).IsInRole([Security.Principal.WindowsBuiltInRole]"Administrator")) {
        Start-Process powershell.exe "-noProfile -ExecutionPolicy Bypass -File `"$PSCommandPath`"" -Verb RunAs
        Exit
    }
}


#functions
try {
    [void][reflection.assembly]::Load('System.Data, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089')
    [void][reflection.assembly]::Load('System.DirectoryServices, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a')
    [void][reflection.assembly]::Load('System.ServiceProcess, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a')
    [void][reflection.assembly]::Load('System.Design, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a')
    [void] [System.Reflection.Assembly]::LoadWithPartialName("System.Drawing") # Draw Stuff on pictures
    [void] [System.Reflection.Assembly]::LoadWithPartialName("System.Windows.Forms") # Create Forms
    [System.Windows.Forms.Application]::EnableVisualStyles() #Embedding different fonts and ressources

    #User32 .Net Library to send keystrokes to the game
    #important part here is mapvirtualkey, which sends the keystroke as hardware emulation, otherwise the api barks at any game that this is a simulated keystroke and could be blocked
    Add-Type @"
        using System;
        using System.Runtime.InteropServices;
        public class User32 {
            [DllImport("user32.dll")] public static extern IntPtr GetForegroundWindow();
            [DllImport("user32.dll")] [return: MarshalAs(UnmanagedType.Bool)] public static extern bool SetForegroundWindow(IntPtr hWnd);
            [DllImport("user32.dll")] [return: MarshalAs(UnmanagedType.Bool)] public static extern bool ShowWindow(IntPtr hWnd, int nCmdShow);
            [DllImport("user32.dll")] public static extern bool SetWindowPos(
                IntPtr hWnd,
                IntPtr hWndInsertAfter,
                int X,
                int Y,
                int cx,
                int cy,
                uint uFlags
            );
        }

        namespace KeyboardEmulator
        {
            public static class KeyboardEmulator
            {
                [DllImport("user32.dll")] public static extern void keybd_event(byte bVk, byte bScan, uint dwFlags, UIntPtr dwExtraInfo);
                [DllImport("user32.dll")] public static extern byte MapVirtualKey(uint uCode, uint uMapType);
                public static void SendKey(byte key)
                {
                    const uint KEYEVENTF_EXTENDEDKEY = 0x0000;
                    const uint KEYEVENTF_KEYUP = 0x0002;
                    keybd_event(key, MapVirtualKey(key, 0), KEYEVENTF_EXTENDEDKEY, (UIntPtr)0);
                    keybd_event(key, MapVirtualKey(key, 0), KEYEVENTF_EXTENDEDKEY | KEYEVENTF_KEYUP, (UIntPtr)0);
                }
                public static void SendKeyAction(byte key, byte key2)
                {
                    keybd_event(key, MapVirtualKey(key, 0), key2, (UIntPtr)0);
                }
            }
            public class Keyboard
            {
                [DllImport("user32.dll", SetLastError = true)] static extern void keybd_event(byte bVk, byte bScan, int dwFlags, int dwExtraInfo);
                [DllImport("user32.dll")] public static extern byte MapVirtualKey(uint uCode, uint uMapType);
                const int KEY_DOWN_EVENT = 0x0000;        //Key down flag
                const int KEY_DOWN_EXTENDED = 0x0001;     //Key extended flag
                const int KEY_UP_EVENT = 0x0002;          //Key up flag
                                                          //UniCode = 0x0004 and ScanCode = 0x0008
    
                public static void HoldKey(byte key, int duration)
                {
                    int PauseBetweenStrokes = duration;
                    keybd_event(key, MapVirtualKey(key, 0), KEY_DOWN_EVENT, 0);
                    System.Threading.Thread.Sleep(PauseBetweenStrokes);
                    keybd_event(key, MapVirtualKey(key, 0), KEY_UP_EVENT, 0);
                }
            }
        }
"@

}
catch {
    msg * 'Unable to load required assemblies'
    return
}

#hotkey detection
<#
$Signature = @'
    [DllImport("user32.dll", CharSet=CharSet.Auto, ExactSpelling=true)] 
    public static extern short GetAsyncKeyState(int virtualKeyCode); 
'@
[System.Reflection.Assembly]::LoadWithPartialName("System.Windows.Forms") | Out-Null
Add-Type -MemberDefinition $Signature -Name Keyboard -Namespace PsOneApi 
$global:arrayofkeys = [System.Collections.ArrayList]@()
$loop = 0
$holdduration = 0
while ($true) {
		Start-Sleep -Milliseconds 10
		if($loop%50 -eq 0){
			$global:arrayofkeys = [System.Collections.ArrayList]@()
			if($state -eq 0){
				$holdduration = 0
			}
		}
		for ($ascii = 9; $ascii -le 254; $ascii++) {
		$state = [PsOneApi.Keyboard]::GetAsyncKeyState($ascii)
		if ($state -eq -32767) {
				$virtualKeyName = [System.Windows.Forms.Keys]$ascii
				$holdduration += 10
				If ($global:arrayofkeys -notcontains $virtualKeyName){$global:arrayofkeys.add($virtualKeyName) | Out-Null}
		}
		else {}

	}

	if($global:arrayofkeys -like "RMenu"){ #Right Altb
		[console]::beep(587,125) #G  
		[console]::beep(587,125) #G
		[console]::beep(659,125) #C
		[console]::beep(587,125) #G
		$RunSpaceSyncData.UpdateLocation = $true
		$global:arrayofkeys = [System.Collections.ArrayList]@()
		Write-Host "Updating player coordinates"
	}

	#DETECT STRG + R
	if($global:arrayofkeys -like "ControlKey*" -AND $global:arrayofkeys -like "*R"){
		#msg * "CTRL + R"
		[console]::beep(500,300)
		#$RunSpaceSyncData.RecalibrateHotkey = $true
		$global:arrayofkeys = [System.Collections.ArrayList]@()
		Write-Host "Recalibrate detected"
	}  
	$loop++
}
#>


function Send-StringToChat($text) {
                                                                        #GET FOCUS OF CURRENT WINDOW
    $StarCitizenProcess = Get-Process | Where-Object {$_.mainWindowTitle } | Where-Object {$_.Name -like "StarCitizen"}     #GET STARCITIZEN PROCESS

    if($StarCitizenProcess -ne 0){                                                          #check if StarCitizen is running
        $StarCitizenHandle = $StarCitizenProcess.MainWindowHandle                           #declare handle of StarCitizen Prozess
        [User32]::SetForegroundWindow($StarCitizenHandle) | Out-Null                        #SetFocus on StarCitizen
        [User32]::ShowWindow($StarCitizenHandle,3) | Out-Null                               #Maximize StarCitizen Window in case borderless mode
        Start-Sleep -Milliseconds 150
        [System.Windows.Forms.SendKeys]::SendWait($text)                                    #Sends content of text variable
        Start-Sleep -Milliseconds 150
    }
}

function Show-SysTrayIcon{
	[System.Windows.Forms.Application]::EnableVisualStyles()
	$form = New-Object 'System.Windows.Forms.Form'
	$notifyicon = New-Object 'System.Windows.Forms.NotifyIcon'
	$contextmenustrip = New-Object 'System.Windows.Forms.ContextMenuStrip'
	$systray_menuitem1 = New-Object 'System.Windows.Forms.ToolStripMenuItem'
	$systray_menuitem2 = New-Object 'System.Windows.Forms.ToolStripMenuItem'
	$systray_menuitem3 = New-Object 'System.Windows.Forms.ToolStripMenuItem'
	$systray_menuitem4 = New-Object 'System.Windows.Forms.ToolStripMenuItem'	
	$systray_menuitem5 = New-Object 'System.Windows.Forms.ToolStripMenuItem'
	$systray_menuitem6 = New-Object 'System.Windows.Forms.ToolStripMenuItem'	
	$notifyicon2 = New-Object 'System.Windows.Forms.NotifyIcon'
	$exitToolStripMenuItem = New-Object 'System.Windows.Forms.ToolStripMenuItem'
	$InitialFormWindowState = New-Object 'System.Windows.Forms.FormWindowState'

	$form_Load = {
	}

	$notifyicon_Click={
	    Write-Host 'Icon accessed'
	}

	$global:systray_menuitem_Click={
		param(
			[string]$textfromsystray
		)

		Write-Host $this.Name

        $StarCitizenProcess = Get-Process | Where-Object {$_.mainWindowTitle } | Where-Object {$_.Name -like "StarCitizen"}
        if($StarCitizenProcess -ne 0){
            #grab current window focus
            $PreviousFocus = [User32]::GetForegroundWindow() 
            $StarCitizenHandle = $StarCitizenProcess.MainWindowHandle
            #focus star citizen
            [User32]::SetForegroundWindow($StarCitizenHandle) | Out-Null                        #SetFocus on StarCitizen
            [User32]::ShowWindow($StarCitizenHandle,3) | Out-Null                               #Maximize StarCitizen Window in case borderless mode
        
			
            #Send text to game
            Start-Sleep -Milliseconds 200
            Send-StringToChat $textfromsystray
            Start-Sleep -Milliseconds 20
        
            #Return focus to previous window
            #[User32]::SetForegroundWindow($PreviousFocus) | Out-Null # sets focus on previous window before script start  
            #[User32]::ShowWindow($PreviousFocus,3) | Out-Null        # sets focus on previous window before script start  
        }
	}


	$exitToolStripMenuItem_Click = {
		$form.Close()
	}
	#region Control Helper Functions
	function Show-NotifyIcon{
			param(
			[Parameter(Mandatory = $true, Position = 0)]
			[ValidateNotNull()]
			[System.Windows.Forms.NotifyIcon]$NotifyIcon,
			[Parameter(Mandatory = $true, Position = 1)]
			[ValidateNotNullOrEmpty()]
			[String]$BalloonTipText,
			[Parameter(Position = 2)]
			[String]$BalloonTipTitle = '',
			[Parameter(Position = 3)]
			[System.Windows.Forms.ToolTipIcon]$BalloonTipIcon = 'None',
			[Parameter(Position = 4)]
			[int]$Timeout = 0
		)
		
		if(-not $NotifyIcon.Icon){
			#Set a Default Icon otherwise the balloon will not show
			$NotifyIcon.Icon = [System.Drawing.Icon]::ExtractAssociatedIcon([System.Windows.Forms.Application]::ExecutablePath)
		}
		
		$NotifyIcon.ShowBalloonTip($Timeout, $BalloonTipTitle, $BalloonTipText, $BalloonTipIcon)
	}


	$form_FormClosed=[System.Windows.Forms.FormClosedEventHandler]{
	#Event Argument: $_ = [System.Windows.Forms.FormClosedEventArgs]
		$notifyicon.Dispose()
	}

	$Form_StateCorrection_Load=
	{
		#Correct the initial state of the form to prevent the .Net maximized form issue
		$form.WindowState = $InitialFormWindowState
	}

	$Form_Cleanup_FormClosed=
	{
		#Remove all event handlers from the controls
		try
		{
			$form.remove_FormClosed($form_FormClosed)
			$form.remove_Load($form_Load)
			$notifyicon.remove_Click($notifyicon_Click)
			$systray_menuitem1.remove_Click($global:systray_menuitem_Click)
			$systray_menuitem2.remove_Click($global:systray_menuitem_Click)
			$systray_menuitem3.remove_Click($global:systray_menuitem_Click)
			$systray_menuitem4.remove_Click($global:systray_menuitem_Click)
			$systray_menuitem5.remove_Click($global:systray_menuitem_Click)
			$systray_menuitem6.remove_Click($global:systray_menuitem_Click)
			$toolstripmenuitem2.remove_Click($toolstripmenuitem2_Click)
			$exitToolStripMenuItem.remove_Click($exitToolStripMenuItem_Click)
			#$triggerHandle.AsyncWaitHandle.WaitOne()
			#$triggerPowerShell.Dispose()
			#$triggerRunspace.Dispose()
			$form.remove_Load($Form_StateCorrection_Load)
			$form.remove_FormClosed($Form_Cleanup_FormClosed)
		}
		catch { Out-Null } # Prevent PSScriptAnalyzer warning
	}
	#endregion Generated Events

	#----------------------------------------------
	#region Generated Form Code
	#----------------------------------------------
	$form.SuspendLayout()
	$contextmenustrip.SuspendLayout()
	$form.AutoScaleDimensions = '8, 17'
	$form.AutoScaleMode = 'Font'
	$form.ClientSize = '423, 230'
	$form.ContextMenuStrip = $contextmenustrip
	$form.ControlBox = $False
	$form.FormBorderStyle = 'FixedDialog'
	$form.Margin = '5, 5, 5, 5'
	$form.MaximizeBox = $False
	$form.MinimizeBox = $False
	$form.Name = 'form1'
	$form.Opacity = 0
	$form.ShowInTaskbar = $False
	$form.StartPosition = 'CenterScreen'
	$form.Text = 'Form'
	$form.add_FormClosed($form_FormClosed)
	$form.add_Load($form_Load)

	# notifyicon
	$icon = [System.Drawing.Icon]::ExtractAssociatedIcon("$script:ScriptDir\Icon.ico") 
	$notifyicon.BalloonTipIcon = 'Info'
	$notifyicon.BalloonTipText = 'Welcome to IconNotfy'
	$notifyicon.BalloonTipTitle = 'My Ballon'
	$notifyicon.ContextMenuStrip = $contextmenustrip
	$notifyicon.Text = 'SG Werbung 1'
	$notifyicon.Icon = $icon
	$notifyicon.Visible = $True
	$notifyicon.add_Click($notifyicon_Click)
	
	### contextmenustrip1 ###
	#########################
	$contextmenustrip.ImageScalingSize = '20, 20'
	$contextmenustrip.Name = 'contextmenustrip1'
	$contextmenustrip.Size = '210, 76'

	$systray_menuitem1.Name = 'systray_menuitem1'
	$systray_menuitem1.Size = '209, 24'
	$systray_menuitem1.Text = 'Textblock 1'
	$systray_menuitem1.add_Click({
		$global:systray_menuitem_Click.Invoke($text1)
	})
	
	$systray_menuitem2.Name = 'systray_menuitem2'
	$systray_menuitem2.Size = '209, 24'
	$systray_menuitem2.Text = 'Textblock 2'
	$systray_menuitem2.add_Click({
		$global:systray_menuitem_Click.Invoke($text2)
	})

	$systray_menuitem3.Name = 'systray_menuitem3'
	$systray_menuitem3.Size = '209, 24'
	$systray_menuitem3.Text = 'Textblock 3'
	$systray_menuitem3.add_Click({
		$global:systray_menuitem_Click.Invoke($text3)
	})

	$systray_menuitem4.Name = 'systray_menuitem4'
	$systray_menuitem4.Size = '209, 24'
	$systray_menuitem4.Text = 'Textblock 4'
	$systray_menuitem4.add_Click({
		$global:systray_menuitem_Click.Invoke($text4)
	})

	$systray_menuitem5.Name = 'systray_menuitem5'
	$systray_menuitem5.Size = '209, 24'
	$systray_menuitem5.Text = 'Textblock 5'
	$systray_menuitem5.add_Click({
		$global:systray_menuitem_Click.Invoke($text5)
	}) 

	$systray_menuitem6.Name = 'systray_menuitem6'
	$systray_menuitem6.Size = '209, 24'
	$systray_menuitem6.Text = 'Textblock 6'
	$systray_menuitem6.add_Click({
		$global:systray_menuitem_Click.Invoke($text6)
	})

	[void]$contextmenustrip.Items.Add($systray_menuitem1)
	[void]$contextmenustrip.Items.Add($systray_menuitem2)
	[void]$contextmenustrip.Items.Add($systray_menuitem3)
	[void]$contextmenustrip.Items.Add($systray_menuitem4)
	[void]$contextmenustrip.Items.Add($systray_menuitem5)
	[void]$contextmenustrip.Items.Add($systray_menuitem6)
	[void]$contextmenustrip.Items.Add($exitToolStripMenuItem)

	# Menu entries

	#
	#
	# notifyicon2
	#
	$notifyicon2.Text = 'notifyicon2'
	$notifyicon2.Visible = $True
	#
	# exitToolStripMenuItem
	#
	$exitToolStripMenuItem.Name = 'exitToolStripMenuItem'
	$exitToolStripMenuItem.Size = '209, 24'
	$exitToolStripMenuItem.Text = 'E&xit'
	$exitToolStripMenuItem.add_Click($exitToolStripMenuItem_Click)
	$contextmenustrip.ResumeLayout()
	$form.ResumeLayout()
	#endregion Generated Form Code

	#----------------------------------------------

	#Save the initial state of the form
	$InitialFormWindowState = $form.WindowState
	#Init the OnLoad event to correct the initial state of the form
	$form.add_Load($Form_StateCorrection_Load)
	#Clean up the control events
	$form.add_FormClosed($Form_Cleanup_FormClosed)
	#Show the Form
	return $form.ShowDialog()
}

# PARAMETERS
$text1 = Get-Content ".\Textblock1.txt"
$text2 = Get-Content ".\Textblock2.txt"
$text3 = Get-Content ".\Textblock3.txt"
$text4 = Get-Content ".\Textblock4.txt"
$text5 = Get-Content ".\Textblock5.txt"
$text6 = Get-Content ".\Textblock6.txt"

#Check if StarCitizen is running with elevated permissions, while powershell runs in user context
if ((Get-Process | Where-Object {$_.mainWindowTitle } | Where-Object {$_.Name -like "StarCitizen"} | Add-Member -Name Elevated -MemberType ScriptProperty -Value {if ($this.Name -in @('Idle','System')) {$null} else {-not $this.Path -and -not $this.Handle} } -PassThru).Elevated){
    # StarCitizen was run with admin permissions, starting script with admin permissions too to gain access to this window
    Set-AdminPermissions
}

# Make PowerShell Disappear - Thanks Chrissy
$windowcode = '[DllImport("user32.dll")] public static extern bool ShowWindowAsync(IntPtr hWnd, int nCmdShow);'
$asyncwindow = Add-Type -MemberDefinition $windowcode -name Win32ShowWindowAsync -namespace Win32Functions -PassThru
$null = $asyncwindow::ShowWindowAsync((Get-Process -PID $pid).MainWindowHandle, 0)
 
# Use a Garbage colection to reduce Memory RAM
# https://dmitrysotnikov.wordpress.com/2012/02/24/freeing-up-memory-in-powershell-using-garbage-collector/
# https://docs.microsoft.com/fr-fr/dotnet/api/system.gc.collect?view=netframework-4.7.2
[System.GC]::Collect()

<#
$triggerScript = {
    if(Test-Path -Path "C:\debug-runspace-hotkey.log" -PathType Leaf){Remove-Item -Path "C:\debug-runspace-hotkey.log" -ErrorAction SilentlyContinue}
    Start-Transcript -Path "C:\debug-runspace-hotkey.log" -Append  | Out-Null


	$Signature = @'
	[DllImport("user32.dll", CharSet=CharSet.Auto, ExactSpelling=true)]
	public static extern short GetAsyncKeyState(int virtualKeyCode);
'@

	Add-Type -MemberDefinition $Signature -Name Keyboard -Namespace PsOneApi
    $global:arrayofkeys = [System.Collections.ArrayList]@()
    $loop = 0
    $holdduration = 0

    while ($true) {
        Start-Sleep -Milliseconds 10

        if ($loop % 50 -eq 0) {
            $global:arrayofkeys = [System.Collections.ArrayList]@()
            if ($state -eq 0) {
                $holdduration = 0
            }
        }

        for ($ascii = 9; $ascii -le 254; $ascii++) {
            $state = [PsOneApi.Keyboard]::GetAsyncKeyState($ascii)
            if ($state -eq -32767) {
                $virtualKeyName = [System.Windows.Forms.Keys]$ascii
                $holdduration += 10
                if ($global:arrayofkeys -notcontains $virtualKeyName) {
                    $global:arrayofkeys.add($virtualKeyName) | Out-Null
                }
            }
        }

        if ($global:arrayofkeys -like "RMenu") { # Right Alt
            [console]::beep(587, 125) # G
            [console]::beep(587, 125) # G
            [console]::beep(659, 125) # C
            [console]::beep(587, 125) # G
            $global:arrayofkeys = [System.Collections.ArrayList]@()
            #global:systray_menuitem_Click.Invoke($global:text1)
			msg * "Text: $text1"
        }

        # Detect Ctrl + R
        if ($global:arrayofkeys -like "ControlKey*" -and $global:arrayofkeys -like "*R") {
            [console]::beep(500, 300)
            $global:arrayofkeys = [System.Collections.ArrayList]@()
        }

        $loop++
    }
}
$triggerRunspace = [runspacefactory]::CreateRunspace()
$triggerRunspace.ApartmentState = "STA"
$triggerRunspace.Open()
$triggerPowerShell = [powershell]::Create()
$triggerPowerShell.Runspace = $triggerRunspace
$triggerPowerShell.AddScript($text1)
$triggerPowerShell.AddScript($triggerScript)
$triggerHandle = $triggerPowerShell.BeginInvoke()
#>

#Call Main Function / SysTray Icon
Show-SysTrayIcon
Pause 